//   .

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

//#include <windows.h>

#include "A4rng.h"

//
int
main (int argc, char **argv)
{
  BYTE hash[1024];
  BYTE str[2048];
  BYTE *e;
  int i,p,j;
  time_t tt;
  FILE *f;

  if(argc<3) {
//               0             1    2
   printf("use:  A4rng-hashstr pwd file\n");
   return -1;
  }

  f = fopen(argv[2],"rt");
  if(!f) {
    printf("err open file: %s\n",argv[2]);
    return -2;
  }

  for(i=1;;i++)
  {
    memset(&hash,0,sizeof(hash));

    e = fgets(str,sizeof(str),f);
    if (!e) break;

    tt = time(0);	//.    32!
                             //         vv-  \n
    p=A4rng_HS((BYTE *)&str, strlen(str)-1, argv[1], strlen(argv[1]), (BYTE *)&hash);

    tt = time(0)-tt;	

    for(j=0;j<p;j++) printf("%02X",hash[j]);
                     printf(" *strNo=%3d (%d sec.)\n",i,tt);
  }

  fclose(f);

  return 0;
}
