// bin24bmp.c
//   3    bmp,
//    
//   
//

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <math.h>

static BYTE cc[16*256*256];
long pp=0;


//     bmp 24 
void CreateBmp24 (char *from, char *to)
{
FILE *inp = fopen(from,"rb");
long inp_sz = _filelength(fileno(inp));

RGBTRIPLE color;
HANDLE hFile;
DWORD RW;
int i, j;

//   
BITMAPFILEHEADER bfh;
BITMAPINFOHEADER bih;
BYTE Palette [1024];					// 

int Width,Height;

	memset (Palette, 0, sizeof(Palette));			//     
	memset (cc, 0, sizeof(cc));			

//  
	Width = Height = (int) sqrt((double)(inp_sz/3));  //3     W*H

printf("from=%s w=%d h=%d to=%s\n",from, Width , Height,to);

	//  
	memset (&bfh, 0, sizeof(bfh));

	bfh.bfType = 0x4D42;				// ,   bmp 'BM'
	bfh.bfOffBits = sizeof(bfh) + sizeof(bih) + 1024;//   1Kb,      
	bfh.bfSize = bfh.bfOffBits + 
			 sizeof(color) * Width * Height + 
			 Height * (Width % 4);		//    

	memset (&bih, 0, sizeof(bih));

	bih.biSize = sizeof(bih);			//  
	bih.biBitCount = 24;				// 24   
	bih.biCompression = BI_RGB;			//  
	bih.biHeight = Height;
	bih.biWidth = Width;
	bih.biPlanes = 1;										//   1
															//     0
	hFile = CreateFile (to, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) return;

	//  
	WriteFile (hFile, &bfh, sizeof (bfh), &RW, NULL);
	WriteFile (hFile, &bih, sizeof (bih), &RW, NULL);

	//  
	WriteFile (hFile, Palette, 1024, &RW, NULL);

// 
	for (i = 0; i < Height; i++)
	{
// :
                pp = fread(cc,1,Width*3,inp);
                if (pp==0) break;

 		WriteFile (hFile, &cc, pp, &RW, NULL);

		//   
		WriteFile (hFile, Palette, Width % 4, &RW, NULL);
	}

fclose(inp);
	CloseHandle(hFile);
}



int
main(int argc, char **argv)
{
  int i;
  char to[1024];

if(argc<2)
{
  printf("Convert binary 3x-byte to 24bit.bmp.\n");

  printf(" ⮪ 3   ଠ bmp 24bit RGB,"
  "  㠫樨 १ ࠡ"
  " ஢ ᥢ砭 ᫥⥫쭮⥩\n"
 );
}


  if (argc>1)
  for(i=1;i<argc;i++)
  {
      memset(to,0,sizeof(to)); strcpy(to,argv[i]);  strcat(to,".24.bmp");
      CreateBmp24 (argv[i],to);
  }
  else printf("use:bin24bmp binary.data\n");

  return 0;
}
