#include <stdio.h>
#include <stdlib.h>

#include "bitio.h"

static __int64 Sum;
// 24 
static __int64 S[256*256*256];

void 
testbit_init(void)
{
   input_bit_initialize();
   memset(S,0,sizeof(S));
   Sum=0;
}

int
testbit01(char *fname, int nb)
{
FILE *inp = fopen(fname,"rb");
long bit,i;

   if (!inp) { return -1; }

   testbit_init();

   while(1){
     bit = input_bitN (inp,nb);
     if (bit<0) break;
     S[bit]++;
     Sum++;
   }

   for(i=0;i<(1<<nb);i++)
     printf("%d \t %I64d \t %f\n",i,S[i],(double)S[i]/Sum);

   printf("\n");

   fclose(inp);
   return 0;
}


int
main(int argc, char **argv)
{
long nb;
   memset(S,0,sizeof(S));
   Sum=0;

   if(argc<2) return -1;

   for(nb=1;nb<16;nb++)
     testbit01(argv[1],nb);

   return 0;
}
