#include <stdio.h>
#include <stdlib.h>

#include "bitio.h"


static __int64 Sum;
// 24 
static __int64 S[256*256][2];

void 
testbit_init(void)
{
   input_bit_initialize();
   memset(S,0,sizeof(S));
   Sum=0;
}

//. 0  1
int
testbit02(char *fname)
{
FILE *inp = fopen(fname,"rb");
long bitprev=0,bit,i;
long nbit=-1;

   if (!inp) { return -1; }

   testbit_init();

   while(1){
     bit = input_bitN (inp,1);

     if (bit<0) break;
     if(nbit<0) { bitprev=bit, nbit=1;} 

     if(bitprev!=bit) { S[nbit][bitprev]++;  nbit=1; goto next;}

     nbit++;

     if (nbit>65535)  { S[nbit][bitprev]++;  nbit=1;}
next:
     bitprev=bit;
     Sum++;
   }

   printf("len  \t  cnt0 \t   offset0   \t      cnt1   \t     offset1\n");
   for(i=1;i<(1<<16);i++)
   {

    if((S[i][0]+S[i][1])<1) continue;

    printf("%2d \t ", i);
    printf("%15I64d \t %8f \t", S[i][0],(double)S[i][0]/Sum);
    printf("%15I64d \t %8f \n",S[i][1],(double)S[i][1]/Sum);

   }
   printf("\n");

   fclose(inp);
   return 0;
}


int
main(int argc, char **argv)
{

   if(argc<2) return -1;

   testbit02(argv[1]);

   return 0;
}
