#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

//          
//: S[byteprev][bytecurr]=count;
//    count   


//         
        
#define TABS(x) ((double)(x)<0.0)?(-x):(x)

static __int64 S1[256][256];                ///    \_  

static BYTE prev1=0;

__int64
avg(void)
{
  long i,j,p;
  __int64 sum=0,cnt=0;

  for(i=0;i<256;i++)
    for(j=0;j<256;j++)
      if (S1[i][j]>0) { sum+=S1[i][j]; cnt++; }

  return sum/cnt;

}

void 
testprev02(char *fn)
{
  FILE *fr = fopen(fn,"rb");
  BYTE buff[64*1024];
  BYTE b;
  long i,j,p;
  __int64 a;

  while(1)
  {
    p= fread(buff,1,sizeof(buff),fr);
    if (p==0) break;
    for(i=0;i<p;i++) {
       b=buff[i];
       S1[prev1][b]++;              ///
       prev1 = b;        ///
    }
  }

  fclose(fr);

/// 
  a = avg();

  for(i=0;i<256;i++)
    for(j=0;j<256;j++)
      if (S1[i][j]>0)
        printf("%02x-%02x =\t %15I64d \t %f \t %d\n",i,j,
                              S1[i][j], TABS((((double)S1[i][j]-a)/a))
                                               ,a);

}



int
main (int argc, char **argv)
{

  if(argc<2)
  {
    printf("use: testprev2 file1\n");
    return -1;
  }

  testprev02(argv[1]);

  return 0;

}

